//+------------------------------------------------------------------+
//|                                                  zz bandymas.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red



extern int ZZ_count=6;                  //?????????? ??????
extern int ZZ_ch=300;                   //???????????? ?????? ??????

extern string ZigZag="Indicator Values"; //?????? ???????
extern int ZZ_dp=12;
extern int ZZ_dv=5;
extern int ZZ_bs=3;

double Ch_ZZ_h[];                       //????? ??????? ??????? ??????
double Ch_ZZ_l[];                       //????? ?????? ??????? ??????
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  double zz_0,                                       //???? ?????? ???????? ???????
       zz_1;                                       //???? ?????? ???????? ???????
int    h_index,                                    //??????? ??????? ???????????
       l_index;                                    //??????? ?????? ???????????
int    h_bar[50],                                  //???? ??????? ???????????
       l_bar[50];                                  //???? ?????? ???????????
double h_price[50],                                //???? ??????? ???????????
       l_price[50];                                //???? ?????? ???????????
int    limit;
int    peak;                                        //??????????? ????
double h_max,                                       //???????? ?? ???????? ???????????
       l_min;                                      //??????? ?? ???????? ???????????



int    counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- main loop
   for(int i=0; i<limit; i++)
    {
      zz_0=GetExtremumZZPrice(NULL, 0, 0, ZZ_dp, ZZ_dv, ZZ_bs);  //???? ?????? ???????? ???????
      zz_1=GetExtremumZZPrice(NULL, 0, 1, ZZ_dp, ZZ_dv, ZZ_bs);  //???? ?????? ???????? ???????

      if(zz_0 > zz_1)                                            //???? ???? ?????? ??????? ?????? ???? ?????? ???????
        {                                                        //?????????? ??? ???????????    
         peak = 1;                                               //???-???????
        }
       else
        {
         if(zz_0 < zz_1)                                         //???? ???? ?????? ??????? ?????? ???? ?????? ???????
             {                                                   //?????????? ??? ??????      
              peak = -1;                                         //???-??????
             }
         else 
         return(0);                                         //???? ??? ??????? ????? ????
        }     
        
        switch(peak)
         {
          case 1: 
                {
                  h_index = 0;                                   // ?????? ?????? ??????? ???????????
                  l_index = 1;                                   // ?????? ?????? ?????? ???????????
    
                  while(h_index <= ZZ_count)                     //???? ?????? ???;?? ???????? ???????????
                    {                                            //???? ???? ??????? ???????????

                      h_bar[h_index] = GetExtremumZZBar(NULL, 0, h_index, ZZ_dp, ZZ_dv, ZZ_bs);

                                                                  //???? ???? ??????? ???????????

                      h_price[h_index] = GetExtremumZZPrice(NULL, 0, h_bar[h_index], ZZ_dp, ZZ_dv, ZZ_bs);

                                                                 //???? ???????????? ???? ????? ???????? ???
                      h_max = ArrayMax(h_price);                 //???????????? ???? ?? ???????? ???
                      Ch_ZZ_h[i] = h_max;                        //?????????? ? ?????
            
                      h_index = h_index+2;                       //??????? ????? ?????? ?????? ????????
                     }
                    while(l_index <= ZZ_count)
                     {
                      l_bar[l_index] = GetExtremumZZBar(NULL, 0, l_index, ZZ_dp, ZZ_dv, ZZ_bs);
                      l_price[l_index] = GetExtremumZZPrice(NULL, 0, l_bar[l_index], ZZ_dp, ZZ_dv, ZZ_bs);
                      l_min = ArrayMin(l_price);
                      Ch_ZZ_l[i] = l_min;
            
                      l_index = l_index+2;
                     }
                   }
            break;
            case -1: 
                   {
                      h_index = 1;                               // ?????? ?????? ??????? ???????????
                      l_index = 0;                               // ?????? ?????? ?????? ???????????
                     while(h_index <= ZZ_count)                     //???? ?????? ???;?? ???????? ???????????
                    {                                            //???? ???? ??????? ???????????

                      h_bar[h_index] = GetExtremumZZBar(NULL, 0, h_index, ZZ_dp, ZZ_dv, ZZ_bs);

                                                                  //???? ???? ??????? ???????????

                      h_price[h_index] = GetExtremumZZPrice(NULL, 0, h_bar[h_index], ZZ_dp, ZZ_dv, ZZ_bs);

                                                                 //???? ???????????? ???? ????? ???????? ???
                      h_max = ArrayMax(h_price);                 //???????????? ???? ?? ???????? ???
                      Ch_ZZ_h[i] = h_max;                        //?????????? ? ?????
            
                      h_index = h_index+2;                       //??????? ????? ?????? ?????? ????????
                     }
                    while(l_index <= ZZ_count)
                     {
                      l_bar[l_index] = GetExtremumZZBar(NULL, 0, l_index, ZZ_dp, ZZ_dv, ZZ_bs);
                      l_price[l_index] = GetExtremumZZPrice(NULL, 0, l_bar[l_index], ZZ_dp, ZZ_dv, ZZ_bs);
                      l_min = ArrayMin(l_price);
                      Ch_ZZ_l[i] = l_min;
            
                      l_index = l_index+2;
                     }
                   }
             break;
      }   
  if (h_max - l_min < ZZ_ch)
 {

int bar_start = GetExtremumZZBar(NULL, 0, ZZ_count, ZZ_dp, ZZ_dv, ZZ_bs);
 SetTLine(Blue, "UP", Time[bar_start], h_max, Time[0], h_max, /*spindulys*/False);
 SetTLine(Red, "DN", Time[bar_start], l_min, Time[0], l_min, /*spindulys*/False);
 }


}

return(0);
}


//-----------------------------------------------------------------------------
//                 OBJ_TREND
//+----------------------------------------------------------------------------+
//|  ??????   : 12.10.2007                                                     |
//|  ???????? : ????????? ??????? OBJ_TREND ????????? ?????                    |
//+----------------------------------------------------------------------------+
//|  ?????????:                                                                |
//|    cl - ???? ?????                                                         |
//|    nm - ????????????               (  ""  - ????? ???????? ???????? ????)  |
//|    t1 - ????? ???????? ????  baro atidarymo laikas      (  0   - Time[10]  |
//|    p1 - ??????? ???????      kaina1      (  0   - Low[10])                 |
//|    t2 - ????? ???????? ????    baro atidarymo laikas(  0   - ??????? ???)  |
//|    p2 - ??????? ???????         kaina2   (  0   - Bid)                     |
//|    ry - ???     spindulys        (False - ?? ????????? pagal nutylejima)   |
//|    st - ????? ?????                (  0   - ??????? ?????)                 |
//|    wd - ?????? ?????               (  1   - ?? ?????????)                  |
//+----------------------------------------------------------------------------+
void SetTLine(color cl, string nm="",
              datetime t1=0, double p1=0, datetime t2=0, double p2=0,
              bool ry=False, int st=0, int wd=1) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , ry);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}

//-----------------------------------------------------------------------------
//          GetExtremumZZPrice  
//+----------------------------------------------------------------------------+
//|  ??????   : 07.10.2006                                                     |
//|  ???????? : ?????????? ????????? ??????? ?? ??? ??????.                    |
//+----------------------------------------------------------------------------+
//|  ?????????:       parametrai                                               |
//|    sy - ???????????? ???????????   (NULL ??? "" - ??????? ??????)          |
//|    tf - ?????????                  (      0     - ??????? ??)              |
//|    ne - ????? ??????????  ekstremumo Nr.         (      0     - ?????????) |
//|    dp - ExtDepth                                                           |
//|    dv - ExtDeviation                                                       |
//|    bs - ExtBackstep                                                        |
//+----------------------------------------------------------------------------+
double GetExtremumZZPrice(string sy="", int tf=0, int ne=0, int dp=12, int dv=5, int bs=3) {
  if (sy=="" || sy=="0") sy=Symbol();
  double zz;
  int    i, k=iBars(sy, tf), ke=0;

  for (i=1; i<k; i++) {
    zz=iCustom(sy, tf, "ZigZag", dp, dv, bs, 0, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(zz);
    }
  }
  Print("GetExtremumZZPrice(): Ekstremumas ZZ Nr. ",ne," nerastas ");
  
  
  return(0);
}

//-----------------------------------------------------------------------------
//         GetExtremumZZBar
//+----------------------------------------------------------------------------+
//|  ??????   : 07.10.2006                                                     |
//|  ???????? : ?????????? ????? ???? ?????????? ??????? ?? ??? ??????.        |
//+----------------------------------------------------------------------------+
//|  ?????????:        parametrai                                              |
//|    sy - ???????????? ???????????   (NULL ??? "" - ??????? ??????)          |
//|    tf - ?????????                  (      0     - ??????? ??)              |
//|    ne - ????? ??????????   ekstremumo Nr.        (      0     - ?????????) |
//|    dp - ExtDepth                                                           |
//|    dv - ExtDeviation                                                       |
//|    bs - ExtBackstep                                                        |
//+----------------------------------------------------------------------------+
int GetExtremumZZBar(string sy="", int tf=0, int ne=0, int dp=12, int dv=5, int bc=3) {
  if (sy=="" || sy=="0") sy=Symbol();
  double zz;
  int    i, k=iBars(sy, tf), ke=0;

  for (i=0; i<k; i++) {
    zz=iCustom(sy, tf, "ZigZag", dp, dv, bc, 0, i);
    if (zz!=0) {
      ke++;
      if (ke>ne) return(i);
    }
  }
  Print("GetExtremumZZBar(): Ekstremumas ZZ Nr. ",ne," nerastas");
  return(-1);
   }
   
//+----------------------------------------------------------------------------+
//|  ??????   : 17.05.2008                                                     |
//|  ???????? : ?????????? ???????? ????????????? ???????? ???????.            |
//+----------------------------------------------------------------------------+
//|  ?????????:                                                                |
//|    x - ?????? ???????? ????????? ????                                      |
//+----------------------------------------------------------------------------+
double ArrayMax(double& x[]) {
  if (ArraySize(x)>0) return(x[ArrayMaximum(x)]);
  else {
    Print("ArrayMax(): ?????? ????!");
    return(0);
  }
}
//+----------------------------------------------------------------------------+
//|  ??????   : 17.05.2008                                                     |
//|  ???????? : ?????????? ???????? ???????????? ???????? ???????.             |
//+----------------------------------------------------------------------------+
//|  ?????????:                                                                |
//|    x - ?????? ???????? ????????? ????                                      |
//+----------------------------------------------------------------------------+
double ArrayMin(double& x[]) {
  if (ArraySize(x)>0) return(x[ArrayMinimum(x)]);
  else {
    Print("ArrayMin(): ?????? ????!");
    return(0);
  }
}

